#!/bin/sh

instdir=`pwd`
gnomedir="/usr/share/gnome/apps"
opsystem=`uname -s`
cpoptions="-a -f"

if [ "$opsystem" = "FreeBSD" ]
then
	gnomedir="/usr/X11R6/share/gnome/apps"
	cpoptions="-p -R -f"
fi

./menupars -c firewall.xml -d 2>/dev/null

mkdir -p /tmp/.fx/desktop
tar -C, --directory /tmp/.fx/desktop -zxf desktop/desktop-gnome2.tar.gz

./menupars -c firewall.xml -i 2>/dev/null

if [ $? -ne 0 ]
then

tar -C, --directory /tmp/.fx/desktop -zxf desktop/desktop-gnome.tar.gz
cd /tmp/.fx

mkdir -p "${gnomedir}/Internet/InJoy Firewall/"
cp ${cpoptions} "desktop/directory" "${gnomedir}/Internet/InJoy Firewall/.directory" 
cat "desktop/InJoy Firewall Server.desktop" | sed s@__INSTALL__@"$instdir"@g > "${gnomedir}/Internet/InJoy Firewall/InJoy Firewall Server.desktop"
cat "desktop/InJoy Firewall GUI.desktop" | sed s@__INSTALL__@"$instdir"@g > "${gnomedir}/Internet/InJoy Firewall/InJoy Firewall GUI.desktop"
cat "desktop/Security Logs.desktop" | sed s@__INSTALL__@"$instdir"@g > "${gnomedir}/Internet/InJoy Firewall/Security Logs.desktop"
cat "desktop/Reload Firewall Configuration.desktop" | sed s@__INSTALL__@"$instdir"@g > "${gnomedir}/Internet/InJoy Firewall/Reload Firewall Configuration.desktop"
mkdir -p "${gnomedir}/Internet/InJoy Firewall/Information/"
cat "desktop/F_X Communications.desktop" | sed s@__INSTALL__@"$instdir"@g > "${gnomedir}/Internet/InJoy Firewall/Information/F_X Communications.desktop"
cat "desktop/Firewall Home.desktop" | sed s@__INSTALL__@"$instdir"@g > "${gnomedir}/Internet/InJoy Firewall/Information/Firewall Home.desktop"
cat "desktop/Firewall Purchase.desktop" | sed s@__INSTALL__@"$instdir"@g > "${gnomedir}/Internet/InJoy Firewall/Information/Firewall Purchase.desktop"
cat "desktop/Online Documentation.desktop" | sed s@__INSTALL__@"$instdir"@g > "${gnomedir}/Internet/InJoy Firewall/Information/Online Documentation.desktop"
cp ${cpoptions} "desktop/directory" "${gnomedir}/Internet/InJoy Firewall/Information/.directory" 
mkdir -p "${gnomedir}/Internet/InJoy Firewall/Log Files/"
cp ${cpoptions} "desktop/directory" "${gnomedir}/Internet/InJoy Firewall/Log Files/.directory" 
cat "desktop/IPSec Logs.desktop" | sed s@__INSTALL__@"$instdir"@g > "${gnomedir}/Internet/InJoy Firewall/Log Files/IPSec Logs.desktop"
cat "desktop/DHCPd Logs.desktop" | sed s@__INSTALL__@"$instdir"@g > "${gnomedir}/Internet/InJoy Firewall/Log Files/DHCPd Logs.desktop"
cat "desktop/PPPoE Logs.desktop" | sed s@__INSTALL__@"$instdir"@g > "${gnomedir}/Internet/InJoy Firewall/Log Files/PPPoE Logs.desktop"
cat "desktop/PPTP Logs.desktop" | sed s@__INSTALL__@"$instdir"@g > "${gnomedir}/Internet/InJoy Firewall/Log Files/PPTP Logs.desktop"
mkdir -p "${gnomedir}/Internet/InJoy Firewall/Tools/"
cp ${cpoptions} "desktop/directory" "${gnomedir}/Internet/InJoy Firewall/Tools/.directory" 
cat "desktop/Restart Firewall.desktop" | sed s@__INSTALL__@"$instdir"@g > "${gnomedir}/Internet/InJoy Firewall/Tools/Restart Firewall.desktop"
cat "desktop/Kill Firewall.desktop" | sed s@__INSTALL__@"$instdir"@g > "${gnomedir}/Internet/InJoy Firewall/Tools/Kill Firewall.desktop"
cat "desktop/Reload IPSec Configuration.desktop" | sed s@__INSTALL__@"$instdir"@g > "${gnomedir}/Internet/InJoy Firewall/Tools/Reload IPSec Configuration.desktop"
cat "desktop/Reload DHCP Server Configuration.desktop" | sed s@__INSTALL__@"$instdir"@g > "${gnomedir}/Internet/InJoy Firewall/Tools/Reload DHCP Server Configuration.desktop"
mkdir -p "${gnomedir}/Internet/InJoy Firewall/Packet Tracing/"
cp ${cpoptions} "desktop/directory" "${gnomedir}/Internet/InJoy Firewall/Packet Tracing/.directory" 
cat "desktop/IP Trace (Start).desktop" | sed s@__INSTALL__@"$instdir"@g > "${gnomedir}/Internet/InJoy Firewall/Packet Tracing/IP Trace (Start).desktop"
cat "desktop/IP Trace (Stop).desktop" | sed s@__INSTALL__@"$instdir"@g > "${gnomedir}/Internet/InJoy Firewall/Packet Tracing/IP Trace (Stop).desktop"
cat "desktop/Format Trace (to Screen).desktop" | sed s@__INSTALL__@"$instdir"@g > "${gnomedir}/Internet/InJoy Firewall/Packet Tracing/Format Trace (to Screen).desktop"
cat "desktop/Delete Trace File.desktop" | sed s@__INSTALL__@"$instdir"@g > "${gnomedir}/Internet/InJoy Firewall/Packet Tracing/Delete Trace File.desktop"
mkdir -p "${gnomedir}/Internet/InJoy Firewall/Extras/"
cp ${cpoptions} "desktop/directory" "${gnomedir}/Internet/InJoy Firewall/Extras/.directory" 
cat "desktop/Admin Remote Firewall.desktop" | sed s@__INSTALL__@"$instdir"@g > "${gnomedir}/Internet/InJoy Firewall/Extras/Admin Remote Firewall.desktop"
cat "desktop/Run Firewall Server in Background.desktop" | sed s@__INSTALL__@"$instdir"@g > "${gnomedir}/Internet/InJoy Firewall/Extras/Run Firewall Server in Background.desktop"
cat "desktop/IP Forwarding (Enable).desktop" | sed s@__INSTALL__@"$instdir"@g > "${gnomedir}/Internet/InJoy Firewall/Extras/IP Forwarding (Enable).desktop"
cat "desktop/IP Forwarding (Disable).desktop" | sed s@__INSTALL__@"$instdir"@g > "${gnomedir}/Internet/InJoy Firewall/Extras/IP Forwarding (Disable).desktop"

mkdir -p "${HOME}/.gnome-desktop/InJoy Firewall/"
cp ${cpoptions} "desktop/directory" "${HOME}/.gnome-desktop/InJoy Firewall/.directory"
cat "desktop/InJoy Firewall Server.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/.gnome-desktop/InJoy Firewall/InJoy Firewall Server.desktop"
cat "desktop/InJoy Firewall GUI.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/.gnome-desktop/InJoy Firewall/InJoy Firewall GUI.desktop"
cat "desktop/Security Logs.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/.gnome-desktop/InJoy Firewall/Security Logs.desktop"
cat "desktop/Reload Firewall Configuration.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/.gnome-desktop/InJoy Firewall/Reload Firewall Configuration.desktop"
mkdir -p "${HOME}/.gnome-desktop/InJoy Firewall/Information/"
cat "desktop/F_X Communications.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/.gnome-desktop/InJoy Firewall/Information/F_X Communications.desktop"
cat "desktop/Firewall Home.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/.gnome-desktop/InJoy Firewall/Information/Firewall Home.desktop"
cat "desktop/Firewall Purchase.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/.gnome-desktop/InJoy Firewall/Information/Firewall Purchase.desktop"
cat "desktop/Online Documentation.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/.gnome-desktop/InJoy Firewall/Information/Online Documentation.desktop"
cp ${cpoptions} "desktop/directory" "${HOME}/.gnome-desktop/InJoy Firewall/Information/.directory"
mkdir -p "${HOME}/.gnome-desktop/InJoy Firewall/Log Files/"
cp ${cpoptions} "desktop/directory" "${HOME}/.gnome-desktop/InJoy Firewall/Log Files/.directory"
cat "desktop/IPSec Logs.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/.gnome-desktop/InJoy Firewall/Log Files/IPSec Logs.desktop"
cat "desktop/DHCPd Logs.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/.gnome-desktop/InJoy Firewall/Log Files/DHCPd Logs.desktop"
cat "desktop/PPPoE Logs.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/.gnome-desktop/InJoy Firewall/Log Files/PPPoE Logs.desktop"
cat "desktop/PPTP Logs.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/.gnome-desktop/InJoy Firewall/Log Files/PPTP Logs.desktop"
mkdir -p "${HOME}/.gnome-desktop/InJoy Firewall/Tools/"
cp ${cpoptions} "desktop/directory" "${HOME}/.gnome-desktop/InJoy Firewall/Tools/.directory"
cat "desktop/Restart Firewall.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/.gnome-desktop/InJoy Firewall/Tools/Restart Firewall.desktop"
cat "desktop/Kill Firewall.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/.gnome-desktop/InJoy Firewall/Tools/Kill Firewall.desktop"
cat "desktop/Reload IPSec Configuration.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/.gnome-desktop/InJoy Firewall/Tools/Reload IPSec Configuration.desktop"
cat "desktop/Reload DHCP Server Configuration.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/.gnome-desktop/InJoy Firewall/Tools/Reload DHCP Server Configuration.desktop"
mkdir -p "${HOME}/.gnome-desktop/InJoy Firewall/Packet Tracing/"
cp ${cpoptions} "desktop/directory" "${HOME}/.gnome-desktop/InJoy Firewall/Packet Tracing/.directory"
cat "desktop/IP Trace (Start).desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/.gnome-desktop/InJoy Firewall/Packet Tracing/IP Trace (Start).desktop"
cat "desktop/IP Trace (Stop).desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/.gnome-desktop/InJoy Firewall/Packet Tracing/IP Trace (Stop).desktop"
cat "desktop/Format Trace (to Screen).desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/.gnome-desktop/InJoy Firewall/Packet Tracing/Format Trace (to Screen).desktop"
cat "desktop/Delete Trace File.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/.gnome-desktop/InJoy Firewall/Packet Tracing/Delete Trace File.desktop"
mkdir -p "${HOME}/.gnome-desktop/InJoy Firewall/Extras/"
cp ${cpoptions} "desktop/directory" "${HOME}/.gnome-desktop/InJoy Firewall/Extras/.directory"
cat "desktop/Admin Remote Firewall.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/.gnome-desktop/InJoy Firewall/Extras/Admin Remote Firewall.desktop"
cat "desktop/Run Firewall Server in Background.desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/.gnome-desktop/InJoy Firewall/Extras/Run Firewall Server in Background.desktop"
cat "desktop/IP Forwarding (Enable).desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/.gnome-desktop/InJoy Firewall/Extras/IP Forwarding (Enable).desktop"
cat "desktop/IP Forwarding (Disable).desktop" | sed s@__INSTALL__@"$instdir"@g > "${HOME}/.gnome-desktop/InJoy Firewall/Extras/IP Forwarding (Disable).desktop"

fi

cd "$instdir"
rm -rf /tmp/.fx/desktop
mkdir -p /usr/share/pixmaps/
cp ${cpoptions} desktop/*.png /usr/share/pixmaps/
