InJoy Firewall for Red Hat Linux.
Platform specific configuration and installation README.



==========================================================================
 	C O N T E N T S
==========================================================================



1.0   Prerequisites
2.0   Installation issues
3.0   System Implications
4.0   User Experience Issues
5.0   Manual Installation
6.0   Manual Deinstallation
7.0   Trouble Shooting



==============================================================================
 1.	P R E R E Q U I S I T E S
==============================================================================



You are about to install a product that adds a new device driver to your 
Linux system. The device driver layers with existing device drivers and 
incompatibility or bugs in these drivers CAN potentially cause hazard to 
your Linux system. 

If you are NOT experienced in the following areas:

     * TCP/IP networking and routing
     * Linux recovery options (i.e. recovery disk or single user mode)

THEN please backup critical data before installing this software
and/or consult a local expert or seek help on the Internet. F/X 
Communications will in no way be held responsible for malfunctions or 
data loss inflicted by our software.



1.1 Supported Software
----------------------

InJoy will run on any of the below Linux platforms:

   * Red Hat Linux 9.0 - see additional notes below
   * Red Hat Linux 8.0
   * Red Hat Linux 7.3
   * Red Hat Linux 7.2
   
May work on other distibutions adhering to the Linux standards base:

   * Red Hat Linux 7.1
   * Red Hat Linux 7.0
   * Red Hat Linux 6.2
   * Red Hat Linux 6.1
   * Debian (currently may require manual installation / followup)

Additional Requirements:

   * Linux 2.4 kernel
   * Glibc 2.1
   * GTK 1.2 and Gnome (for GUI applications)


1.2 Supported Hardware
----------------------

The InJoy Firewall has been tested with a multitude of Network Adapters
on Linux. Below a small list of (some of) the tested adapters:

  * NE2000 compatible (ne.o driver)
  * 3Com Fast EtherLink/EtherLink XL Family
  * 3Com 3C905xx (100Mb PCI Adapter)
  * 3Com Etherlink III 16BIT-ISA 
  * RTL8029 / RTL8129 PCI Ethernet Adapter
  * IBM Etherjet 100
  * D-Link DL2000-based Gigabit Ethernet Adapter
  * Intel PRO/1000 82544GC Gigabit Ethernet Controller
  * Intel PRO/1000 82540EM Gigabit Ethernet Controller
  * Many more...

If you use PCMCIA network adapters, be sure to check the trouble-shooting
section.

If you have one of the following (1Gbit) network cards, you must use
a 2.4.20+ kernel version (preferably the latest 2.4 kernel).

e1000.o:
	Controller  Adapter Name                         Board IDs
	----------  ------------                         ---------

	82542       PRO/1000 Gigabit Server Adapter      700262-xxx, 717037-xxx
	82543       PRO/1000 F Server Adapter            738640-xxx, A38888-xxx
	82543       PRO/1000 T Server Adapter            A19845-xxx, A33948-xxx
	82544       PRO/1000 XT Server Adapter           A51580-xxx
	82544       PRO/1000 XF Server Adapter           A50484-xxx
	82544       PRO/1000 T Desktop Adapter           A62947-xxx
	82540       PRO/1000 MT Desktop Adapter          A78408-xxx
	82541                                            C91016-xxx
	82545       PRO/1000 MT Server Adapter           A92165-xxx
	82546       PRO/1000 MT Dual Port Server Adapter A92111-xxx
	82545       PRO/1000 MF Server Adapter           A91622-xxx
	82545       PRO/1000 MF Server Adapter(LX)       A91624-xxx
	82546       PRO/1000 MF Dual Port Server Adapter A91620-xxx

The following network cards will not work in 2.4 kernels:

  * Broadcom Tigon3
  * Broadcom 4400
  * 3Com 3CR990


==============================================================================
 2.	I N S T A L L A T I O N   I S S U E S
==============================================================================



2.1 General issues
------------------

The installation script will install the required libraries in /usr/lib and
install boot scripts in /etc.  For this reason the installation script must
be run as root. It will also create a file called /etc/fx.conf.  This file
should contain a space separated list of the network modules that 
InJoy Firewall will monitor.

Many users of Red Hat (and other) Linux distributions are accustomed to 
using configuration programs such as netconfig or Network Configurator.  
Using these utilities with InJoy Firewall is perfectly acceptable, but 
after making changes with such a utility you must rerun the InJoy Firewall 
Install.sh script. The script will convert any settings from the files 
that the configuration program generates to ones that will work with InJoy 
Firewall.

InJoy must be run as root, or have root privileges for creating routes, 
and accessing the /dev entries.

If your Red Hat distribution is not using one of the supported kernels
(indicated by the install script), follow the included instructions to
build the InJoy driver manually. See source/build.txt for help.


2.2 Upgrade issues
------------------

When upgrading to a new version, it is recommended you run install.sh
after un-tar'ing. If you don't wish to run install.sh, then be sure
to manually copy the new libraries to usr/lib.

When creating the menu items on the Gnome Menu, old items are not destroyed.
If you are upgrading from a previous install, you should either run the
uninstall script or manually remove the old menu items to ensure there are
no obsolete items.


2.3 Red Hat 9 additional installation issues:
----------------------------------------------------------------

Red Hat 9 now includes and uses the Native POSIX Thread Library
(NPTL), which is an improved implementation of the POSIX threads
for Linux.
 
The NPTL library can cause problems (hangs) for applications that
extensively use semaphores, such as the InJoy Firewall. The InJoy
Firewall is tested with the new NPTL library, however not as
extensively as with the older thread libraries.

To completely eliminate this "concern", you can set the environment
variable LD_ASSUME_KERNEL to 2.4.1, which means that the older
"Linuxthreads with floating stacks" library will be used. For more
information on LD_ASSUME_KERNEL, see Red Hat Linux 9 Release Notes:

   http://ftp.redhat.com/pub/redhat/linux/9/en/os/i386/RELEASE-NOTES

To set up the environment variable, login as root, and add the
following line to the end of ~/.bashrc

   export LD_ASSUME_KERNEL=2.4.1

This assumes that you are using the default bash shell for the Linux
users. Setting environment variables in other shells may differ from
this example, so check your shell's manual page or set bash as the
root user's shell (you can do this by editing the /etc/passwd file).



==============================================================================
 3.	S Y S T E M   I M P L I C A T I O N S
==============================================================================



InJoy installs a device driver with hooks for talking to both other device
drivers and to create dynamic PPP devices.

Drivers loaded by InJoy firewall are modified on the fly to talk to the
InJoy device driver directly.

After installing InJoy any ethernet devices (eth0, eth1 etc) will then be
called (fx0, fx1, etc).

Boot scripts in /etc are modified to reflect these changes.



==============================================================================
 4.	U S E R   E X P E R I E N C E   I S S U E S
==============================================================================



DW_BORDER_WIDTH and DW_BORDER_HEIGHT environment variables are used to
control the perceived size of the windows. The default border-widths
used are for the Red Hat 6.2 - 7.2 window managers default theme.



==============================================================================
 5.	M A N U A L   I N S T A L L A T I O N
==============================================================================



Manual installation is quite tricky.  To begin, when the driver is installed
and network drivers link to it, eth# becomes fx# (where # is a number 0-9). 

1) Any references to eth0 must be changed to fx0 in the /etc boot scripts.
   Also interface configation scripts which contain the device name need to 
   be copied to the fx name.  For instance ifcfg-eth0 should be copied to
   ifcfg-fx0.

2) Then you need to locate the fx.o object in sys/x.x.x (where x.x.x is the
   kernel version) for your kernel. And copy it into 
   /lib/modules/x.x.x/kernel/drivers/net/.  

3) All of the libraries in the lib/ subdirectory need to be copied to 
   /usr/lib or somewhere else that is listed in the /etc/ld.so.conf. Then 
   /sbin/ldconfig needs to be run to recognise the newly installed libraries.

4) Then the boot scripts must be installed.  sys/fx goes into 
   /etc/rc.d/init.d, sys/S10fx and sys/S90fx must go into the runlevel which 
   you want to boot into. These scripts are named so that they load the fx.o 
   driver before the network initializes.  
   
5) A statically linked version of objcopy needs to be placed in 
   /bin/fx_objcopy. One is distributed as sys/fx_objcopy. Also sys/findsym
   must be placed in /bin.

6) Finally you must create a file called /etc/fx.conf with a space delimited
   list of network drivers that InJoy should load. (coresponding to your LAN
   hardware).

Then all that is required is a reboot.



==============================================================================
 6.	M A N U A L   D E I N S T A L L A T I O N
==============================================================================



All that is required for deinstallation is deleting all of the files that
were installed during the installation phase and restore all instances of
eth# from their current fx#. 

Here is a list of files to delete:

   /etc/rc.d/rc?.d/S10fx
   /etc/rc.d/rc?.d/S90gateway
   /etc/rc.d/init.d/fx
   /etc/fx.conf
   /etc/fx_forward
   /bin/fx_objcopy
   /bin/findsym
   /etc/sysconfig/network-scripts/ifcfg-fx*
   /etc/sysconfig/networking/devices/ifcfg-fx*
   /etc/sysconfig/networking/profiles/default/ifcfg-fx*
   /usr/share/gnome/apps/Internet/InJoy Firewall/*
   /usr/lib/libfirewall.so*
   /usr/lib/libfxip.so*
   /usr/lib/libfxmasq.so*
   /usr/lib/libfxutil.so*
   /usr/lib/libipfrag.so*
   /usr/lib/libfxipsec.so*
   /usr/lib/libdhcpd.so*
   /usr/lib/libpppoe.so*
   /usr/lib/libpptp.so*
   /usr/lib/libgenerate.so*
   /usr/lib/libdw.so*
   /usr/lib/libdwcompat.so*
   /usr/share/pixmaps/gateway.png
   /usr/share/pixmaps/gwxp.png
   /usr/share/pixmaps/logview.png



==============================================================================
 7.	T R O U B L E   S H O O T I N G
==============================================================================



Q: InJoy Firewall sees only outgoing packets or doesn't see any packets
   at all.

A: Follow these steps to locate and fix the problem:

    a) Make sure the fx.o module is loaded and operational. You can do this
       by running the "/sbin/lsmod" command and verify "fx" presence. If not
       found, load it manually by running "modprobe fx".

    b) Make sure Linux uses "patched" network drivers. You can do this
       by running "/sbin/lsmod" and verify your NIC drivers end
       with "_fx" - like this:

         dl2k_fx                18628   1
         e1000_fx               71616   2

       If there's no "_fx" ending, make sure relevant drivers are listed
       in /etc/fx.conf, separated by whitespace:

         dl2k e1000

       Reboot after making changes.

     c) If Linux still loads unpatched drivers, make sure the
        drivers are accessible under /lib/modules/<version>/drivers/net.
        If your driver is located in one of the sub-directories, e.g.
        wireless, list the sub-directory in /etc/fx.conf as well:

          wireless/orinoco wireless/orinoco_cs dl2k e1000/e1000

        Reboot after making changes.

     d) Make sure that /etc/modules.conf contains correct module
        aliases, i.e. modules must have "_fx" ending. An example of
        correct modules.conf (excerpt):

          alias fx0 e1000_fx
          alias fx1 e1000_fx
          alias fx2 dl2k_fx

     e) PCMCIA NIC drivers require changing the /etc/pcmcia/config
        file to reflect new module names. Additional details of PCMCIA
        operation can be found in relevant man pages ("man pcmcia").

        Certain PCMCIA NIC drivers involve more than one module for
        operation, e.g. "orinoco.o" and "orinoco_cs.o". Ensure that
        both are added in /etc/fx.conf.
  
NOTE: InJoy Firewall may not work correctly with 2.5 and 2.6 kernels.
Typical behaviour is not seeing incoming packets. To fix it,
disable NAPI in the kernel configuration, recompile it and re-install.
Work is in progress to implement NAPI support in the Firewall driver.
